module Main where 

import CGI hiding (div, head, map, span, Text)
import RawCGIInternal
import CGIOutput
import CGITypes
import System
import Wiki

import Text.ParserCombinators.Parsec

testDB = createPGB "wave" "wiki" "wiki" "12wiki34db"

--main = start [] cgi

main = do 
	db <- testDB
	runWithHook [] (\(key:act) -> sp db key act ) $ sp db "MainPage" [] 

ps a = standardQuery "Hello" a

editPage db key = do 
	s <- io $ getCurrent db key 
	s' <- case s of
		Nothing -> return ""
		Just (x,_) -> return x
	standardQuery key $ do
		t <- p $ makeTextarea s' (attr_SS "rows" "10" ## attr_SS "cols" "75" ## attr_SS "colspan" "2")
		p (text "Author: ") 
		a <- textInputField (fieldSIZE 20)
		p (text "Comment: ") 
		c <- textInputField (fieldSIZE 20)
		--p $ submit (F2 t a) testing (attr "value" "Send")
		p $ defaultSubmit (F3 t a c) (savePage db key) (attr "value" "Send")
		--submit0 (sp db key []) (attr "value" "Send1")

sp db key _ = do
	s <- io $ getCurrent db key 
	standardQuery key $ showPage db key s

savePage db key (F3 t a c) = do
	s <- io $ update db key fulltext author comment
	standardQuery key $ do
	text "Updated with revision: "
	text s
	address (hlink (URL {unURL = ("wiki?"++key)}) (text "Back to keyword") )
  where
  	fulltext = value t
	author = value a
	comment = value c 

showPage db key s = do
		case s of
			Nothing -> text "No text added for this keyword"
			Just (full, date) -> do
				case parse wikiParser "" full of
					Right n -> ex n	
					Left e -> do
						text "PARSE ERROR: "
						text (show e)
						p $ text full
				p $ text $ "Last edited: "++date
		footer db key

footer db key = do
	hr empty
	submit0 (editPage db key) (attr "value" "Edit")
	--address (hlink (URL {unURL = ("wiki?"++key++"+edit")}) (text "Edit this page") 

ex [] = return ()
ex ((Paragraph):xs) = do
	p empty
	ex xs
ex ((Text s):xs) = do
	text s
	ex xs
ex ((Link l d):xs) = do
	hlink (URL {unURL = ("wiki?"++l)}) (text d)
	ex xs

ex2 [] = []
ex2 ((Paragraph):xs) = "<p>"++ex2 xs
ex2 ((Text s):xs) = s++ex2 xs
ex2 ((Link l d):xs) = "<link: "++l++" desc: "++d++">"++ex2 xs


test s = case parse wikiParser "" s of
					Right n -> do 
						print (ex2 n)
					Left e -> do
						print e
